/*
From philb@iag.net Mon Aug 28 21:51:38 1995
Path: news.iag.net!netline-fddi.jpl.nasa.gov!usenet.eel.ufl.edu!newsfeed.internetmci.com!news.sprintlink.net!parsifal.nando.net!usenet
From: stanl@nando.net
Newsgroups: comp.lang.clipper
Subject: Re: Dbf to exel or lotus conversion ??
Date: Mon, 28 Aug 95 18:47:38 PDT
Organization: News & Observer Public Access
Lines: 141
Message-ID: <NEWTNews.809661112.30406.stanl@stanl.nando.net>
References: <41slq8$g3v@news.xs4all.nl>
NNTP-Posting-Host: grail1512.nando.net
Mime-Version: 1.0
Content-Type: TEXT/PLAIN; charset=US-ASCII
X-Newsreader: NEWTNews & Chameleon -- TCP/IP for MS Windows from NetManage



> I am looking for the source or library for converting databases to
> excel or lotus worksheets. Does anyone know where I can get this?

> Theo Bruin
> allset@xs4all.nl
>

The following code will convert a dbf to Lotus 2.01 [wk1] format:

[there is an additional obj file that can be linked to achieve true floating
point numerics]

*** summer 87 style
*/

PROC prcess   // used to get the database

para mfle

USE (mfle)   // the database in question
handle = lopen(mfle)
for x=1 to fcount()
   fld=field(x)
   DO CASE
   CASE type(fld) ='D'
      lwidth(handle,x-1,9)
   CASE type(fld) ='L'
      lwidth(handle,x-1,2)
   CASE type(fld) ='C'
      lwidth(handle,x-1,len( &fld) )
   CASE type(fld) ='N'
      IF getdecs(&fld) = 0
         lwidth(handle,x-1,int((len(str(&fld))+2)*4/3))  && make wide enough for commas
      ELSE
         lwidth(handle,x-1,len(str(&fld)))
      endIF
   ENDC
   lput(handle,fld,x-1,0)  && put in labels
next
DO while ! eof() .and. inkey() <>27
   for x=1 to fcount()
      fld=field(x)
      lput(handle, &fld,x-1,recno())
   next
   @13,40 say str(recno())+" Records copied"
   SKIP
ENDD
lclose(handle)
RETURN

** lopen(file)
** open a file as a lotus worksheet
** RETURN  dos handle, -1 on error

FUNCTION lopen
param fname
private mname,handle

IF ! "." $ fname
   mname=trim(fname)+".wk1"
ELSE
   mname=fname
ENDI
handle =fcreate(mname,0)
** put in bof string
IF handle <>-1
   fwrite(handle,chr(0)+chr(0)+chr(2)+chr(0)+chr(6)+chr(4))
ENDI
RETURN handle


*lwidth(handle,col,width)
* SET width of specified column to width in file handle
FUNCTION lwidth
param handle, col, width
RETURN fwrite(handle,chr(8)+chr(0)+chr(3)+chr(0)+lotwrd(col)+chr(width))


*lput(handle,val,col,row)
* put a value into cell col, row
FUNCTION lput
param handle,val,col,row
private mstr, decs

DO CASE
CASE type("val")="C"
   mstr=chr(15)+chr(0)+lotwrd(len(val)+7)+chr(255)+lotwrd(col)+lotwrd(row)+"'"+val+chr(0)
CASE type("val")="D"
   mstr=chr(14)+chr(0)+chr(13)+chr(0)+chr(249)+lotwrd(col)+lotwrd(row)+cfloat(val-ctod('01/01/00')+2)
CASE type("val")="N"
   decs=getdecs(val)
   IF decs <>0
      mstr=chr(14)+chr(0)+chr(13)+chr(0)+chr(128+decs)+lotwrd(col)+lotwrd(row)+cfloat(val)
   ELSE
      mstr=chr(14)+chr(0)+chr(13)+chr(0)+chr(192)+lotwrd(col)+lotwrd(row)+cfloat(val)
   ENDI
CASE type("val")="L"
   mstr=chr(15)+chr(0)+chr(8)+chr(0)+chr(255)+lotwrd(col)+lotwrd(row)+"'"+if(val,"Y","N")+chr(0)
ENDC
RETURN fwrite(handle,mstr)


****lclose(handle)
** CLOSE a lotus file
FUNCTION lclose
param handle
fwrite(handle,chr(01)+chr(0)+chr(0)+chr(0))
fclose(handle)
RETURN .t.

FUNCTION lotwrd
** RETURN the lotus format of a number (lsb first)
param mvalue
RETURN chr(mvalue%256)+chr(int(mvalue/256))

FUNCTION getdecs
** get number of decimal places in a number
param mnum
private smnum, at
smnum=str(mnum)
at=at('.',smnum)
IF at=0
   RETURN 0
ELSE
   RETURN len(smnum)-at
ENDI

/*
stan littlefield
BTI
*/


